Summary:     The Samba (SMB) server
Name:        samba
Version:     3.0.13
Release:     4.pp
License:     GPL
Group:       System Environment/Daemons
Source0:     http://www.%{name}.org/%{name}/ftp/%{name}-%{version}.tar.gz
Source1:     samba.logrotate
Source2:     samba.sysconfig
Source3:     smb.init
Source4:     winbind.init
Source5:     samba.lmhosts
Patch0:      samba-Makefile-idmap_ldap.patch
Patch1:      samba-pdb_ldap-fix.patch
Patch2:      samba-sig_oplock.patch
URL:         http://www.%{name}.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Samba Team
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Requires:    %{name}-common = %{version}-%{release} %{name}-common.pp
Requires:    perl
Provides:    %{name}.pp
Prereq:      /bin/bash /sbin/ldconfig
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install
BuildPrereq: glibc-devel readline-devel krb5-devel >= 1.4 openldap22-devel
BuildPrereq: pam-devel ncurses-devel perl
ExclusiveOS: linux

%description
Samba provides an SMB/CIFS server which can be used to
provide network file and print services to SMB/CIFS
clients, including various versions of MS Windows, OS/2,
and other Linux machines. Samba also provides some SMB
clients, which complement the built-in SMB filesystem in
Linux. Samba uses NetBIOS over TCP/IP (NetBT) protocols
and does NOT need NetBEUI (Microsoft Raw NetBIOS frame)
protocol. Samba 3.0 also introduces UNICODE support and
kerberos/ldap integration as a member server in a Windows
2000 domain.


%package devel
Summary:     Development tools for the Samba server
Group:       Development/Libraries
Requires:    %{name}-common = %{version}-%{release} %{name}-common.pp
Requires:    ncurses readline
Provides:    %{name}-devel.pp

%package common
Summary:     Files used by both Samba servers and clients
Group:       Environment/Console
Requires:    glibc krb5-libs openldap22 pam
Provides:    %{name}-common.pp

%package client
Summary:     The Samba (SMB) client programs
Group:       Environment/Console
Requires:    %{name}-common = %{version}-%{release} %{name}-common.pp
Requires:    ncurses readline perl
Provides:    %{name}-client.pp

%package swat
Summary:     The Samba (SMB) server configuration program
Group:       Environment/Console
Requires:    %{name} = %{version}-%{release} %{name}.pp
Provides:    %{name}-swat.pp


%description devel
The %{name}-devel package contains the static libraries
and header files for developing software for Samba.

%description common
The %{name}-common package provides files necessary for
both the server and client packages of Samba.

%description client
The %{name}-client package provides some SMB clients to
compliment the built-in SMB filesystem in Linux. These
clients allow access of SMB shares and printing to SMB
printers.

%description swat
The %{name}-swat package includes the new SWAT (Samba
Web Administration Tool), for remotely managing Samba's
smb.conf file using your favorite Web browser.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
# prepare docs
mv docs/*.pdf docs/registry .


%build
export CFLAGS="$RPM_OPT_FLAGS"
cd source
./configure \
	--prefix=/usr                     \
	--with-configdir=/etc/samba       \
	--with-privatedir=/etc/samba      \
	--localstatedir=/var              \
	--mandir=/usr/share/man           \
	--with-swatdir=/usr/share/swat    \
	--with-sambabook=/usr/share/swat/using_samba \
	--with-logfilebase=/var/log/samba \
	--with-piddir=/var/run/samba      \
	--with-lockdir=/var/cache/samba   \
	--enable-static                   \
	--enable-shared                   \
	--disable-cups                    \
	--with-fhs                        \
	--with-smbwrapper                 \
	--with-ldap                       \
	--with-ads                        \
	--with-ldapsam                    \
	--with-krb5=/usr/kerberos         \
	--with-smbmount                   \
	--with-pam                        \
	--with-pam_smbpass                \
	--with-syslog                     \
	--with-quotas                     \
	--with-utmp                       \
	--with-libsmbclient               \
	--with-acl-support                \
	--with-manpages-langs=en          \
	--with-winbind                    \
	--with-included-popt              \
	--with-shared-modules=pdb_ldap,idmap_ldap,idmap_rid
make proto
make all
make modules
make nsswitch/libnss_wins.so
make debug2html
make bin/smbget
make bin/vfstest


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
pushd source
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/{logrotate,pam,rc.d/init,xinetd}.d
mkdir -p $RPM_BUILD_ROOT/etc/{samba,sysconfig}
mkdir -p $RPM_BUILD_ROOT/lib/security
mkdir -p $RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/var/{cache,log,spool}/samba
make \
	DESTDIR=$RPM_BUILD_ROOT \
	install
# install misc
install -m 755 script/mksmbpasswd.sh $RPM_BUILD_ROOT/usr/bin
install -m 755 bin/debug2html $RPM_BUILD_ROOT/usr/sbin
install -m 755 bin/smbget $RPM_BUILD_ROOT/usr/bin
install -m 755 bin/vfstest $RPM_BUILD_ROOT/usr/bin
mv $RPM_BUILD_ROOT/usr/bin/smb*mount $RPM_BUILD_ROOT/usr/sbin
ln -sf /usr/sbin/smbmount $RPM_BUILD_ROOT/sbin/mount.smbfs
ln -sf /usr/sbin/smbmount $RPM_BUILD_ROOT/sbin/mount.smb
install -m 755 nsswitch/libnss_wins.so $RPM_BUILD_ROOT/lib
ln -sf libnss_wins.so $RPM_BUILD_ROOT/lib/libnss_wins.so.2
install -m 755 nsswitch/libnss_winbind.so $RPM_BUILD_ROOT/lib
ln -sf libnss_winbind.so $RPM_BUILD_ROOT/lib/libnss_winbind.so.2
install -m 755 nsswitch/pam_winbind.so $RPM_BUILD_ROOT/lib/security
install -m 755 bin/pam_smbpass.so $RPM_BUILD_ROOT/lib/security
mv $RPM_BUILD_ROOT/usr/lib/samba/libsmbclient* $RPM_BUILD_ROOT/usr/lib
chmod a-x $RPM_BUILD_ROOT/usr/include/*.h $RPM_BUILD_ROOT/usr/lib/*.*a
ldconfig -n $RPM_BUILD_ROOT/usr/lib
popd
# install dist specific
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/samba
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/samba
install -m 644 packaging/RedHat/samba.pamd.stack $RPM_BUILD_ROOT/etc/pam.d/samba
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/smb
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d/winbind
install -m 644 packaging/RedHat/samba.xinetd $RPM_BUILD_ROOT/etc/xinetd.d/samba
install -m 644 packaging/RedHat/smb.conf $RPM_BUILD_ROOT/etc/samba
install -m 644 packaging/RedHat/smbusers $RPM_BUILD_ROOT/etc/samba
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/samba/lmhosts
install -m 755 packaging/RedHat/smbprint $RPM_BUILD_ROOT/usr/bin
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/{editreg,log2pcap,smbsh}.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/mount.cifs.8*
# prepare docs
mv $RPM_BUILD_ROOT/usr/share/swat/using_samba .
mv $RPM_BUILD_ROOT/usr/share/swat/help/Samba-* .


%post
if [ $1 = 1 ]; then
  /sbin/chkconfig --add smb
  /sbin/chkconfig smb on
fi
if [ -s /etc/samba/smb.conf ]; then
  if [ -f /var/lock/subsys/smb ]; then
    /etc/rc.d/init.d/smb restart
  fi
fi

%post common
/sbin/ldconfig
if [ $1 = 1 ]; then
  /sbin/chkconfig --add winbind
  /sbin/chkconfig winbind off
fi
if [ -s /etc/samba/smb.conf ]; then
  if [ -f /var/lock/subsys/winbind ]; then
    /etc/rc.d/init.d/winbind restart
  fi
fi
# Add services
if ! grep netbios-ns /etc/services >/dev/null 2>&1; then
  echo -e "netbios-ns\t137/tcp" >> /etc/services
  echo -e "netbios-ns\t137/udp" >> /etc/services
fi
if ! grep netbios-dgm /etc/services >/dev/null 2>&1; then
  echo -e "netbios-dgm\t138/tcp" >> /etc/services
  echo -e "netbios-dgm\t138/udp" >> /etc/services
fi
if ! grep netbios-ssn /etc/services >/dev/null 2>&1; then
  echo -e "netbios-ssn\t139/tcp" >> /etc/services
  echo -e "netbios-ssn\t139/udp" >> /etc/services
fi
if ! grep microsoft-ds /etc/services >/dev/null 2>&1; then
  echo -e "microsoft-ds\t445/tcp" >> /etc/services
  echo -e "microsoft-ds\t445/udp" >> /etc/services
fi
if ! grep wins /etc/services >/dev/null 2>&1; then
  echo -e "wins\t\t1512/tcp" >> /etc/services
  echo -e "wins\t\t1512/udp" >> /etc/services
fi

%post swat
if [ $1 = 1 ]; then
  /sbin/chkconfig --add samba
  /sbin/chkconfig samba on
fi
# Add service
if ! grep swat /etc/services >/dev/null 2>&1; then
  echo -e "swat\t\t901/tcp" >> /etc/services
  echo -e "swat\t\t901/udp" >> /etc/services
fi


%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig smb off
  /sbin/chkconfig --del smb
  if [ -f /var/lock/subsys/smb ]; then
    /etc/rc.d/init.d/smb stop
  fi
fi

%preun common
if [ $1 = 0 ]; then
  /sbin/chkconfig winbind off
  /sbin/chkconfig --del winbind
  if [ -f /var/lock/subsys/winbind ]; then
    /etc/rc.d/init.d/winbind stop
  fi
fi

%preun swat
if [ $1 = 0 ]; then
  /sbin/chkconfig samba off
  /sbin/chkconfig --del samba
fi


%postun common
/sbin/ldconfig


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc COPYING Manifest README REVISION Read* Roadmap WHATSNEW*
%doc Samba-Guide.pdf Samba-HOWTO-Collection.pdf
%doc %dir examples registry Samba-Guide Samba-HOWTO-Collection
%doc %dir using_samba
%config(noreplace) /etc/logrotate.d/*
%config(noreplace) /etc/pam.d/*
/etc/rc.d/init.d/smb
%config(noreplace) /etc/samba/smbusers
%config(noreplace) /etc/sysconfig/*
/usr/bin/mksmbpasswd.sh
/usr/bin/smbstatus
/usr/bin/smbcontrol
/usr/bin/tdbbackup
/usr/bin/pdbedit
/usr/bin/tdbdump
/usr/bin/tdbtool
/usr/bin/profiles
/usr/bin/ntlm_auth
%dir /usr/lib/samba/vfs
/usr/lib/samba/vfs/*
%dir /usr/lib/samba/idmap
/usr/lib/samba/idmap/*
%dir /usr/lib/samba/rpc
#/usr/lib/samba/rpc/*
%dir /usr/lib/samba/auth
#/usr/lib/samba/auth/*
/usr/sbin/debug2html
/usr/sbin/nmbd
/usr/sbin/smbd
/usr/share/man/man1/ntlm_auth*
/usr/share/man/man1/profiles*
/usr/share/man/man1/smbcontrol*
/usr/share/man/man1/smbstatus*
/usr/share/man/man8/nmbd*
/usr/share/man/man8/smbd*
/usr/share/man/man8/pdbedit*
/usr/share/man/man8/tdbbackup*
/usr/share/man/man8/tdbdump*
%dir %attr(1777,root,root) /var/spool/samba

%files devel
%defattr(-,root,root)
%doc Samba-Developers-Guide.pdf
%doc %dir Samba-Developers-Guide
/usr/bin/vfstest
/usr/include/*
/usr/lib/*.*a
/usr/share/man/man1/vfstest*

%files common
%defattr(-,root,root)
%dir /etc/samba
%config(noreplace) /etc/samba/smb.conf
%config(noreplace) /etc/samba/lmhosts
/etc/rc.d/init.d/winbind
/lib/*.so*
/lib/security/*.so
/usr/bin/net
/usr/bin/smbpasswd
/usr/bin/test*
/usr/bin/wbinfo
/usr/lib/*.so*
%dir /usr/lib/samba
/usr/lib/samba/*.dat
%dir /usr/lib/samba/pdb
/usr/lib/samba/pdb/*
%dir /usr/lib/samba/charset
/usr/lib/samba/charset/*
/usr/sbin/winbindd
/usr/share/man/man1/test*
/usr/share/man/man1/wbinfo*
/usr/share/man/man5/smbpasswd*
/usr/share/man/man5/smb.conf*
/usr/share/man/man5/lmhosts*
/usr/share/man/man7/samba*
/usr/share/man/man8/net*
/usr/share/man/man8/winbindd*
/usr/share/man/man8/pam_winbind*
%dir %attr(755,root,root) /var/cache/samba
%dir %attr(700,root,root) /var/log/samba
%dir %attr(755,root,root) /var/run/samba

%files client
%defattr(-,root,root)
/sbin/*
/usr/bin/findsmb
/usr/bin/smbmnt
/usr/bin/nmblookup
/usr/bin/rpcclient
/usr/bin/smbclient
/usr/bin/smbspool
/usr/bin/smbtree
/usr/bin/smbprint
/usr/bin/smbtar
/usr/bin/smbget
/usr/bin/smbcacls
/usr/bin/smbcquotas
/usr/sbin/smb*mount
/usr/share/man/man1/findsmb*
/usr/share/man/man1/nmblookup*
/usr/share/man/man1/rpcclient*
/usr/share/man/man1/smbclient*
/usr/share/man/man1/smbtree*
/usr/share/man/man1/smbtar*
/usr/share/man/man1/smbget*
/usr/share/man/man1/smbcacls*
/usr/share/man/man1/smbcquotas*
/usr/share/man/man5/smbgetrc*
/usr/share/man/man8/smbmnt*
/usr/share/man/man8/smbspool*
/usr/share/man/man8/smb*mount*

%files swat
%defattr(-,root,root)
%config(noreplace) /etc/xinetd.d/*
/usr/lib/samba/*.msg
/usr/sbin/swat
/usr/share/man/man8/swat*
%dir /usr/share/swat
/usr/share/swat/*


%changelog
* Thu Mar 31 2005 peter.pramberger@member.fsf.org
- new version 3.0.13
- minor change in smb.init to shutdown nmbd
- added patch to fix oplock/RT_SIGNAL bug

* Wed Mar 23 2005 peter.pramberger@member.fsf.org
- created

